package com.xkrs.microservice.model.entity;

import com.fasterxml.jackson.annotation.JsonIgnore;
import io.micrometer.core.instrument.util.StringUtils;
import org.geolatte.geom.Geometry;

import javax.persistence.*;

/**
 * TeaGardenPlotEntity 表实体类
 * @author tajochen
 */
@Entity
@Table(name="tea_garden_plot")
public class TeaGardenPlotEntity {


    private static final long serialVersionUID = 4359709211352400087L;

    /**
     * 指定主键，建立自增序列，主键值取自序列
     */
    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE, generator = "tea_garden_plot_gen")
    @SequenceGenerator(name = "tea_garden_plot_seq_gen", sequenceName = "tea_garden_plot_seq",allocationSize = 1)
    private Integer id;

    @Column( length = 255, columnDefinition = "varchar(255)")
    private String dkbh;

    @Column( length = 255, columnDefinition = "varchar(255)")
    private String dlmc;

    private Double tbmj;

    @Column( length = 255, columnDefinition = "varchar(255)")
    private String trlx;

    @Column( length = 255, columnDefinition = "varchar(255)")
    private String lxr;

    @Column( length = 255, columnDefinition = "varchar(255)")
    private String lxdh;

    @Column( length = 255, columnDefinition = "varchar(255)")
    private String zuowu;

    private Integer status;

    @Column( length = 255, columnDefinition = "varchar(255)")
    private String remarks;

    private Geometry geom;

    @Transient
    private String wktGeom;

    public Integer getId() {
        return id;
    }

    public void setId(Integer id) {
        this.id = id;
    }

    public String getDkbh() {
        return dkbh;
    }

    public void setDkbh(String dkbh) {
        this.dkbh = dkbh;
    }

    public String getDlmc() {
        return dlmc;
    }

    public void setDlmc(String dlmc) {
        this.dlmc = dlmc;
    }

    public Double getTbmj() {
        return tbmj;
    }

    public void setTbmj(Double tbmj) {
        this.tbmj = tbmj;
    }

    public String getLxr() {
        return lxr;
    }

    public void setLxr(String lxr) {
        this.lxr = lxr;
    }

    public String getTrlx() {
        return trlx;
    }

    public void setTrlx(String trlx) {
        this.trlx = trlx;
    }

    public String getLxdh() {
        return lxdh;
    }

    public void setLxdh(String lxdh) {
        this.lxdh = lxdh;
    }

    public String getZuowu() {
        return zuowu;
    }

    public void setZuowu(String zuowu) {
        this.zuowu = zuowu;
    }

    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    public String getRemarks() {
        return remarks;
    }

    public void setRemarks(String remarks) {
        this.remarks = remarks;
    }

    @JsonIgnore
    public Geometry getGeom() {
        return geom;
    }

    @JsonIgnore
    public void setGeom(Geometry geom) {
        this.geom = geom;
    }

    public String getWktGeom() {
        if(StringUtils.isNotBlank(wktGeom)){
            return wktGeom;
        } else if(geom == null){
            return "";
        } else {
            return geom.toString();
        }
    }

    public void setWktGeom(String wktGeom) {
        this.wktGeom = wktGeom;
    }

    @Override
    public String toString() {
        return "TeaGardenPlotEntity{" +
                "id=" + id +
                ", dkbh='" + dkbh + '\'' +
                ", dlmc='" + dlmc + '\'' +
                ", tbmj=" + tbmj +
                ", trlx='" + trlx + '\'' +
                ", lxr='" + lxr + '\'' +
                ", lxdh='" + lxdh + '\'' +
                ", zuowu='" + zuowu + '\'' +
                ", status=" + status +
                ", remarks='" + remarks + '\'' +
                ", geom=" + geom +
                ", wktGeom='" + wktGeom + '\'' +
                '}';
    }
}
